## mingw-w64-qt6-grpc-6.7.1-1.src.tar.zst

=== src/wellknown/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_protobuf_module(ProtobufWellKnownTypes
    GENERATE_CPP_EXPORTS
    SOURCES
        qtprotobufwellknowntypesglobal.h
        qprotobufanysupport.cpp qprotobufanysupport.h
    PUBLIC_LIBRARIES
        Qt::Protobuf
    LIBRARIES
        Qt::ProtobufPrivate
)

qt_internal_add_protobuf_wellknown_types(ProtobufWellKnownTypes
    any
    api
    duration
    empty
    field_mask
    source_context
    struct
    timestamp
    type
    wrappers
)

=== src/tools/qtgrpcgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_get_tool_target_name(target_name qtgrpcgen)
qt_internal_add_tool(${target_name}
    TARGET_DESCRIPTION "Qt gRPC generator"
    INSTALL_DIR "${INSTALL_LIBEXECDIR}"
    TOOLS_TARGET Grpc
    CORE_LIBRARY None
    EXCEPTIONS
    SOURCES
        main.cpp
        qgrpcgenerator.cpp qgrpcgenerator.h
        grpctemplates.cpp grpctemplates.h
        serverdeclarationprinter.cpp serverdeclarationprinter.h
        clientdeclarationprinter.cpp clientdeclarationprinter.h
        clientdefinitionprinter.cpp clientdefinitionprinter.h
        qmlclientdeclarationprinter.cpp qmlclientdeclarationprinter.h
        qmlclientdefinitionprinter.cpp qmlclientdefinitionprinter.h
    EXTRA_CMAKE_FILES
        "${CMAKE_CURRENT_SOURCE_DIR}/${QT_CMAKE_EXPORT_NAMESPACE}GrpcToolsMacros.cmake"
    EXTRA_CMAKE_INCLUDES
        "${QT_CMAKE_EXPORT_NAMESPACE}GrpcToolsMacros.cmake"
    LIBRARIES
        WrapProtobuf::WrapLibProtoc
        QtProtocCommon
)

qt_internal_return_unless_building_tools()

qt_record_extra_package_dependency(${target_name} WrapProtoc "")

if(MSVC)
    # Disable C4251:
    # `class 'type1' needs to have dll-interface to be used by clients of class 'type2'`
    # which can be generated from some of the protobuf headers on msvc.
    # This warning is also disabled globally in Qt in QtCore/qcompilerdetection.h
    target_compile_options(${target_name}
        PRIVATE "/wd4251"
    )
    target_compile_definitions(${target_name}
        PRIVATE "_SILENCE_CXX17_ITERATOR_BASE_CLASS_DEPRECATION_WARNING"
    )
endif()

=== tests/auto/grpcquick/http2channel/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_grpc_http2channel_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_grpc_http2channel_qml
    QMLTEST
    SOURCES
        tst_grpchttp2channel_qml.cpp
    LIBRARIES
        Qt::Qml
        Qt::GrpcQuick
)

qt_policy(SET QTP0001 NEW)

qt_add_qml_module(tst_grpc_http2channel_qml
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_grpchttp2channel.qml
)

qt_autogen_tools_initial_setup(tst_grpc_http2channel_qml)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_grpc_http2channel_qml)
endif()

=== tests/auto/protobuf/optional/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_optional LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt6_add_protobuf(tst_protobuf_optional_gen
    PROTO_FILES
        ../../shared/data/proto/optional.proto
)

qt_autogen_tools_initial_setup(tst_protobuf_optional_gen)

qt_internal_add_test(tst_protobuf_optional
    SOURCES
        tst_protobuf_optional.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_optional_gen
)
qt_autogen_tools_initial_setup(tst_protobuf_optional)

qt_internal_add_test(tst_protobuf_serialization_optional
    SOURCES
        tst_protobuf_serialization_optional.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_optional_gen
)
qt_autogen_tools_initial_setup(tst_protobuf_serialization_optional)

qt_internal_add_test(tst_protobuf_deserialization_optional
    SOURCES
        tst_protobuf_deserialization_optional.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_optional_gen
)
qt_autogen_tools_initial_setup(tst_protobuf_deserialization_optional)

=== tests/auto/protobuf/wellknown/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_wellknown LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_protobuf_any
    SOURCES
        tst_protobuf_any.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        Qt::ProtobufWellKnownTypes
)

qt6_add_protobuf(tst_protobuf_any
    PROTO_FILES
        ../../shared/data/proto/anymessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufWellKnownTypes,QT_PROTO_INCLUDES>
)

qt_internal_add_test(tst_protobuf_timestamp
    SOURCES
        tst_protobuf_timestamp.cpp
    LIBRARIES
        Qt::Test
        Qt::ProtobufWellKnownTypes
)

qt6_add_protobuf(tst_protobuf_timestamp
    PROTO_FILES
        ../../shared/data/proto/timestampmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufWellKnownTypes,QT_PROTO_INCLUDES>
)
qt_autogen_tools_initial_setup(tst_protobuf_basictypes_gen)

=== tests/auto/protobufqml/nested/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_nested_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_nestedtypes_qtprotobuf_qmltest
    QMLTEST
    SOURCES
        tst_protobuf_nested_qml.cpp
    LIBRARIES
        Qt::Qml
)

qt_policy(SET QTP0001 NEW)

qt_add_protobuf(tst_nestedtypes_qtprotobuf_qml
    PROTO_FILES
        ../../protobuf/nested/proto/nestedmessages.proto
        ../../protobuf/nested/proto/externalpackage.proto
    QML
    QML_URI
        qtprotobufnamespace.tests.nested
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)

qt_add_qml_module(tst_nestedtypes_qtprotobuf_qmltest
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_nested.qml
)

qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qmltest)
qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qml)
qt_autogen_tools_initial_setup(tst_nestedtypes_qtprotobuf_qmlplugin)

qt_add_protobuf(tst_externalpackage_qtprotobuf_qml
    PROTO_FILES
        ../../protobuf/nested/proto/externalpackage.proto
    QML
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_externalpackage_generated"
)

qt_autogen_tools_initial_setup(tst_externalpackage_qtprotobuf_qml)
qt_autogen_tools_initial_setup(tst_externalpackage_qtprotobuf_qmlplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_nestedtypes_qtprotobuf_qmltest)
    qt_import_qml_plugins(tst_nestedtypes_qtprotobuf_qml)
    qt_import_qml_plugins(tst_externalpackage_qtprotobuf_qml)
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-grpc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.7.1
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt gRPC and Protobuf generator and bindings. (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgrpc.git"
msys2_references=(
  'archlinux: qt6-grpc'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-grpc"
             "${MINGW_PACKAGE_PREFIX}-protobuf"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('9ca434f8f1261b3e1ffbe178418b9784f01a005f5b88341e24c735daec0acfa0')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-grpc() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-abseil-cpp"
           "${MINGW_PACKAGE_PREFIX}-grpc"
           "${MINGW_PACKAGE_PREFIX}-protobuf"
           "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-grpc-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
